function updatePic(src) {
  return src + '!a-3-960x.jpg';
}

var imgLoading = '';

/*function playGif(){
  var reg = /\.gif!\w-\d-\d{3}x\.(png|jpg|jpeg|webp)/im;
  $('article .p-image img').each(function(){
    var img = $(this);
    if(reg.test(img.attr('data-src'))){
      img.parent().after('<i class="ico-gift"></i>');
      img.parents('a').click(function(){
        var img = $(this).find('img');
        img.attr('src', img.attr('src').replace(reg,'.gif'));
        $(this).find('.ico-gift').remove();
        return false;
      });
    }
  });
}*/

function playGif(_img) {
  var reg = /\.gif!\w-\d-\d{3}x\.(png|jpg|jpeg|webp)/im;
  var img = $(_img);
  if (reg.test(img.attr('src'))) {
    img.parent().after('<i class="ico-gift"></i>');
    img.parents('a').one('click', function() {
      var src = img.attr('src').replace(reg, '.gif');
      var loader = $(this).find('.ico-gift').removeClass('ico-gift').addClass('loader');
      $('<img/>').bind('load', function() {
        img.attr('src', src)
        loader.remove();
      }).attr('src', src);
      return false;
    });
  }
}

function getOffsetTop(elm) {
  var mOffsetTop = elm.offsetTop;
  var mOffsetParent = elm.offsetParent;
  while (mOffsetParent) {
    mOffsetTop += mOffsetParent.offsetTop;
    mOffsetParent = mOffsetParent.offsetParent;
  }
  return mOffsetTop;
}

function lazyload() {
  var img = document.getElementsByTagName('article')[0].getElementsByTagName('img');
  var remainImg = [];
  var bodyscrollTop = document.body.scrollTop;
  var cliHeight = document.documentElement.clientHeight;
  for (var i = 0; i < img.length; i++) {
    if (img[i].getAttribute('data-src')) {
      img[i].src = imgLoading;
      remainImg.push(img[i]);
    }
  }
  if (remainImg.length == 0) {
    window.removeEventListener('scroll', lazyload, false);
    return 0;
  }
  for (var i = 0; i < remainImg.length; i++) {
    if (getOffsetTop(remainImg[i].parentNode) < (bodyscrollTop + cliHeight)) {
      (function(idx) {
        var imgT = new Image();
        imgT.onload = function() {
          var holder = remainImg[idx].parentNode;
          remainImg[idx].src = imgT.src;
          holder.removeAttribute('class');
          //Comment.jsLog('imgT.src---'+imgT.src+',width = '+this.width);
          if (parseInt(this.width) > 180) //如果图片宽度大于180，则按照规则整行显示
          {
            remainImg[idx].setAttribute('style', 'opacity:0');
            alphaImg(remainImg[idx]);
            playGif(remainImg[idx]);
          }
          if (holder.getAttribute('data-type') == 'video') {
            holder.setAttribute('class', 'videoholder');
            var iconV = document.createElement('div');
            iconV.setAttribute('class', 'video_icon');
            iconV.setAttribute('style', 'top:50%;left:50%');
            //iconV.setAttribute('style','top:'+(remainImg[idx].height-74)/2+'px;left:'+(holder.offsetWidth/2-37)+'px');
            holder.appendChild(iconV);
          }
        }
        imgT.src = remainImg[idx].getAttribute('data-src');
        imgT.src = Comment.updatePic ? Comment.updatePic(imgT.src) : updatePic(imgT.src);
        //imgT.src = updateSrc(imgT.src,Comment.getPicWidth());
        remainImg[idx].removeAttribute('data-src');
      })(i);
    }
  }
}
lazyload();
document.addEventListener('scroll', lazyload, false);
//1.去掉之前mobileme判断是否切图成功判断
//2.包含sdnsoe不包含mobileme（自产生图片）采用_280_157.jpg下划线拼发获取相应图片,包含mobileme 不包含sdnsoe（自产生gif格式图片）采用_280.jpg下划线拼发获取相应图片 不需要拼高
//3.两个都不包含、两个都包含采用!a-3-280x.jpg拼发获取相应图片
function updateSrc(img, width) {
  var tmp = img;
  var sdnsoe = 'sdnsoe';
  var mobileme = 'mobileme';
  Comment.jsLog('updateSrc---' + tmp);
  if (tmp.indexOf('_' + width) >= 0) return tmp;
  var itme = tmp.split("\\.");
  var picFormat = item[item.length - 1];
  Comment.jsLog('updateSrc---' + picFormat);
  if (tmp.indexOf(sdnsoe) >= 0 && tmp.indexOf(mobileme) < 0) {
    return tmp + '_280_157.' + picFormat;
  }
  if (tmp.indexOf(sdnsoe) < 0 && tmp.indexOf(mobileme) >= 0) {
    return tmp + '_' + width + '.' + picFormat;
  }
  if (tmp.indexOf(sdnsoe) < 0 && tmp.indexOf(mobileme) < 0 || tmp.indexOf(sdnsoe) >= 0 && tmp.indexOf(mobileme) >= 0) {
    Comment.jsLog('updateSrc---' + tmp + '!a-3-' + width + 'x.' + picFormat);
    return tmp + '!a-3-' + width + 'x.' + picFormat;
  }
}

function alphaImg(img) {
  var opac = 0;

  var t = setInterval(function() {
    opac += 0.2;
    if (opac > 1) {
      opac = 1;
      clearInterval(t);
    }
    img.setAttribute('style', 'opacity:' + opac);
    img.style.display = 'block';
    img.style.width = '100%';
  }, 100)
}
var Comment = window.Comment || {};
//android,ios
Comment.sys = '{whatsys}';
Comment.gotoComment = function() {
  scrollTo(0, getOffsetTop(document.getElementById('comment')));
}

Comment.update = function(data, operation) {
  Comment.jsLog("---------------" + data);
  document.getElementById('comment').getElementsByClassName('loading')[0].style.display = 'none';
  Comment.jsLog(operation);
  switch (operation) {
    case 'refresh':
      document.getElementsByClassName('comment_list')[0].innerHTML = Comment.makeHTML(data, 1);
      break;
    case 'append':
      document.getElementsByClassName('comment_list')[0].innerHTML += Comment.makeHTML(data, 1);
      break;
    default:
      alert('non-existing operation!');
      break;
  }
  Comment.makeLoadMore(data);
}

Comment.loadGameRelated = function(game) {
    //game = decodeURI(game);
    document.getElementById('game_related_area').innerHTML = game;
  }
  //更多评论按钮
Comment.makeLoadMore = function(dataJson) {
  var data = dataJson.comments;
  if (data.length >= 3) {
    document.getElementById('loadingMoreComment').style.display = 'block';
    return;
  }
  document.getElementById('loadingMoreComment').style.display = 'none';
  return;
}
Comment.makeHTML = function(dataJSON, canReply) {
  var tmpl = '';
  var btn_reply = '';
  //从json中获取评论数据
  var data = dataJSON.comments;
  /* if(data.length == 1){//可以处理加载失败
    if(data[0].content.localeCompare('fail') == 0){
      return '<div class="no_comment">fail</div>';
    }
  } */
  //只有第一次调用收到空评论才显示沙发寂寞
  if (data.length == 0) {
    return '<div class="no_comment">暂时还没有评论哦~快来抢沙发~</div>';
  }

  for (var i = 0; i < data.length; i++) {
    if (data[i].ip_location == '') {
      tmpl += '<div class="comment_item"><div><h3 class="comment_name">' + data[i].nickname + '<span class="comment_address"></span></h3></div><div class="comment_time">' + Comment.getTimeString(data[i].create_time) + '</div><p class="comment_content">' + data[i].content + '</p></div>';
    } else {
      tmpl += '<div class="comment_item"><div><h3 class="comment_name">' + data[i].nickname + '<span class="comment_address">【' + data[i].ip_location + '】</span></h3></div><div class="comment_time">' + Comment.getTimeString(data[i].create_time) + '</div><p class="comment_content">' + data[i].content + '</p></div>';
    }
    //tmpl += '<div class="comment_item"> <div class="comment_content">'+data[i].content+'</div> <h4><ins datetime="'+Comment.getTimeString(data[i].create_time)+'">'+Comment.getTimeString(data[i].create_time)+'</ins>'+data[i].nickname+'</h4> </div>'
  };
  return tmpl;
}

Comment.getTimeString = function(interval) {
  var serverTime = new Date(interval);
  var serverYear = serverTime.getFullYear();
  var serverMonth = serverTime.getMonth() + 1;
  var serverDay = serverTime.getDate();
  var serverHour = serverTime.getHours();
  var serverMinutes = serverTime.getMinutes();
  var serverSeconds = serverTime.getSeconds();

  var timeValue1 = ((serverHour < 10) ? "0" : "") + serverHour + "";
  timeValue1 += ((serverMinutes < 10) ? ":0" : ":") + serverMinutes + "";
  timeValue1 += ((serverSeconds < 10) ? ":0" : ":") + serverSeconds + "";

  var timeValue2 = serverYear;
  timeValue2 += ((serverMonth < 10) ? "-0" : "-") + serverMonth + "";
  timeValue2 += ((serverDay < 10) ? "-0" : "-") + serverDay + "";

  var timetext = timeValue2 + " " + timeValue1
  return timetext;
}

Comment.getChineseTimeString = function(interval) {
  var now = new Date();
  var nowYear = now.getFullYear();
  var nowMonth = now.getMonth() + 1;
  var nowDay = now.getDate();
  var nowHour = now.getHours();
  var nowMinutes = now.getMinutes();

  interval = now.getTime() - serverTime.getTime();
  if (0 <= interval && interval < 60 * 1000) {
    return "刚刚";
  } else if (60 * 1000 <= interval && interval < 60 * 60 * 1000) {
    return parseInt(interval / (60 * 1000)) + "分钟前";
  } else if (60 * 60 * 1000 <= interval && interval < 24 * 60 * 60 * 1000) {
    return parseInt(interval / (60 * 60 * 1000)) + "小时前";
  } else if (((24 * 60 * 60 * 1000 <= interval) && interval < 365 * 24 * 60 * 60 * 1000) || 0 > interval) {
    return serverMonth + '月' + serverDay + '日';
  } else {
    //(interval>365*24*60*60*1000)
    return serverYear + '年';
  }
  if (interval > 0) {
    //年相等
    if (nowYear == serverYear) {
      //当天
      if (nowMonth == serverMonth && nowDay == serverDay) {
        if (0 <= interval && interval < 60 * 1000) {
          return "刚刚";
        } else if (60 * 1000 <= interval && interval < 60 * 60 * 1000) {
          return parseInt(interval / (60 * 1000)) + "分钟前";
        } else if (60 * 60 * 1000 <= interval && interval < 24 * 60 * 60 * 1000) {
          return parseInt(interval / (60 * 60 * 1000)) + "小时前";
        }
      } else //超过1天
      {
        return serverMonth + '月' + serverDay + '日';
      }
    } else //超过1年
    {
      return serverYear + '年';
    }
  }
  return serverMonth + '月' + serverDay + '日';
}

//objectC 调用协议
function oc_cmd(method, args) {
  var cmdStr = 'oc::' + method + '(' + args + ')';
  window.location.href = cmdStr;
  return false;
}

function loadComment(page) {
  if (Comment.sys == 'android') {
    Comment.load(page);
  } else if (Comment.sys == 'ios') {
    oc_cmd('load', page.toString());
  }
}
loadComment(1);

$(function() {
  //获取浏览器的宽高
  var browserWidth = parseInt(document.documentElement.clientWidth, 10),
    browserHeight = parseInt(document.documentElement.clientHeight, 10),
    count = 0, //滑动屏数
    ad = null; //自动滑动句柄
  var figureNumber;
  Comment.loadAdvList = function(game, length) {
    document.getElementById('slider').innerHTML = '<div class="new-hot-libao-box  swipe-wrap clear" id="figuer_list"></div>';

    document.getElementById('figuer_list').innerHTML = game;
    Comment.jsLog1("bttom---------------" + game);
    var numStr = "";
    if (length > 1) {
      for (var i = 0; i < length; i++) {
        if (i == 0) {
          numStr += "<li class=\"current\"></li>";
        } else {
          numStr += "<li></li>";
        }
      }
      document.getElementById('position').innerHTML = numStr;
    }
    Comment.jsLog1("bttom---------------" + numStr);
    var slider = Swipe(document.getElementById('slider'), {
      auto: 5000,
      continuous: true,
      callback: function(pos) {
        var i = bullets.length;
        while (i--) {
          bullets[i].className = ' ';
        }
        bullets[pos].className = 'current';
      }
    });
    var bullets = document.getElementById('position').getElementsByTagName('li');
  }

  Comment.loadBottomAdv = function(game) {
    Comment.jsLog1("bttom---------------" + game);
    document.getElementById('bottom-adv').innerHTML = game;
    Comment.jsLog1("---------------" + game);
  }

  function downloadApp() {
    window.location.href = "http://www.baidu.com";
  }
});

function Swipe(container, options) {

  "use strict";

  // utilities
  var noop = function() {}; // simple no operation function
  var offloadFn = function(fn) {
    setTimeout(fn || noop, 0)
  }; // offload a functions execution

  // check browser capabilities
  var browser = {
    addEventListener: !!window.addEventListener,
    touch: ('ontouchstart' in window) || window.DocumentTouch && document instanceof DocumentTouch,
    transitions: (function(temp) {
      var props = ['transformProperty', 'WebkitTransform', 'MozTransform', 'OTransform', 'msTransform'];
      for (var i in props)
        if (temp.style[props[i]] !== undefined) return true;
      return false;
    })(document.createElement('swipe'))
  };

  // quit if no root element
  if (!container) return;
  var element = container.children[0];
  var slides, slidePos, width;
  options = options || {};
  var index = parseInt(options.startSlide, 10) || 0;
  var speed = options.speed || 500;
  options.continuous = options.continuous ? options.continuous : true;

  function setup() {

    // cache slides
    slides = element.children;

    // create an array to store current positions of each slide
    slidePos = new Array(slides.length);

    // determine width of each slide
    width = container.getBoundingClientRect().width || container.offsetWidth;

    element.style.width = (slides.length * width) + 'px';

    // stack elements
    var pos = slides.length;
    /*if(pos == 1){
      return;
    }*/
    while (pos--) {

      var slide = slides[pos];

      slide.style.width = width + 'px';
      slide.setAttribute('data-index', pos);

      if (browser.transitions) {
        slide.style.left = (pos * -width) + 'px';
        move(pos, index > pos ? -width : (index < pos ? width : 0), 0);
      }

    }

    if (!browser.transitions) element.style.left = (index * -width) + 'px';

    container.style.visibility = 'visible';

  }

  function prev() {

    if (index) slide(index - 1);
    else if (options.continuous) slide(slides.length - 1);

  }

  function next() {

    if (index < slides.length - 1) slide(index + 1);
    else if (options.continuous) slide(0);

  }

  function slide(to, slideSpeed) {

    // do nothing if already on requested slide
    if (index == to) return;

    if (browser.transitions) {

      var diff = Math.abs(index - to) - 1;
      var direction = Math.abs(index - to) / (index - to); // 1:right -1:left

      while (diff--) move((to > index ? to : index) - diff - 1, width * direction, 0);

      move(index, width * direction, slideSpeed || speed);
      move(to, 0, slideSpeed || speed);

    } else {

      animate(index * -width, to * -width, slideSpeed || speed);

    }

    index = to;

    offloadFn(options.callback && options.callback(index, slides[index]));

  }

  function move(index, dist, speed) {
    var pos = slides.length;
    if (pos == 1) {
      return;
    }
    translate(index, dist, speed);
    slidePos[index] = dist;

  }

  function translate(index, dist, speed) {

    var slide = slides[index];
    var style = slide && slide.style;

    if (!style) return;

    style.webkitTransitionDuration =
      style.MozTransitionDuration =
      style.msTransitionDuration =
      style.OTransitionDuration =
      style.transitionDuration = speed + 'ms';

    style.webkitTransform = 'translate(' + dist + 'px,0)' + 'translateZ(0)';
    style.msTransform =
      style.MozTransform =
      style.OTransform = 'translateX(' + dist + 'px)';

  }

  function animate(from, to, speed) {

    // if not an animation, just reposition
    if (!speed) {

      element.style.left = to + 'px';
      return;

    }

    var start = +new Date;

    var timer = setInterval(function() {

      var timeElap = +new Date - start;

      if (timeElap > speed) {

        element.style.left = to + 'px';

        if (delay) begin();

        options.transitionEnd && options.transitionEnd.call(event, index, slides[index]);
        clearInterval(timer);
        return;
      }

      element.style.left = (((to - from) * (Math.floor((timeElap / speed) * 100) / 100)) + from) + 'px';

    }, 4);

  }

  // setup auto slideshow
  var delay = options.auto || 0;
  var interval;

  function begin() {

    interval = setTimeout(next, delay);

  }

  function stop() {

    //delay = 0;
    delay = options.auto > 0 ? options.auto : 0;
    clearTimeout(interval);

  }


  // setup initial vars
  var start = {};
  var delta = {};
  var isScrolling;

  // setup event capturing
  var events = {

    handleEvent: function(event) {

      switch (event.type) {
        case 'touchstart':
          this.start(event);
          break;
        case 'touchmove':
          this.move(event);
          break;
        case 'touchend':
          offloadFn(this.end(event));
          break;
        case 'webkitTransitionEnd':
        case 'msTransitionEnd':
        case 'oTransitionEnd':
        case 'otransitionend':
        case 'transitionend':
          offloadFn(this.transitionEnd(event));
          break;
        case 'resize':
          offloadFn(setup.call());
          break;
      }

      if (options.stopPropagation) event.stopPropagation();

    },
    start: function(event) {

      var touches = event.touches[0];

      // measure start values
      start = {

        // get initial touch coords
        x: touches.pageX,
        y: touches.pageY,

        // store time to determine touch duration
        time: +new Date

      };

      // used for testing first move event
      isScrolling = undefined;

      // reset delta and end measurements
      delta = {};

      // attach touchmove and touchend listeners
      element.addEventListener('touchmove', this, false);
      element.addEventListener('touchend', this, false);
      var pos = slides.length;
      //      Comment.jsLog('-----start'+pos);
      if (pos > 1) {
        Comment.isCanScrollBack(false);
        Comment.isCanScrollForwardBack(false);
      } else {
        Comment.isCanScrollBack(true);
        Comment.isCanScrollForwardBack(true);
      }
    },
    move: function(event) {
      // ensure swiping with one touch and not pinching
      if (event.touches.length > 1 || event.scale && event.scale !== 1) return

      if (options.disableScroll) event.preventDefault();

      var touches = event.touches[0];

      // measure change in x and y
      delta = {
        x: touches.pageX - start.x,
        y: touches.pageY - start.y
      }

      // determine if scrolling test has run - one time test
      if (typeof isScrolling == 'undefined') {
        isScrolling = !!(isScrolling || Math.abs(delta.x) < Math.abs(delta.y));
      }

      // if user is not trying to scroll vertically
      if (!isScrolling) {

        // prevent native scrolling
        event.preventDefault();

        // stop slideshow
        stop();

        // increase resistance if first or last slide
        delta.x =
          delta.x /
          ((!index && delta.x > 0 // if first slide and sliding left
              || index == slides.length - 1 // or if last slide and sliding right
              && delta.x < 0 // and if sliding at all
            ) ?
            (Math.abs(delta.x) / width + 1) // determine resistance level
            : 1); // no resistance if false

        // translate 1:1
        translate(index - 1, delta.x + slidePos[index - 1], 0);
        translate(index, delta.x + slidePos[index], 0);
        translate(index + 1, delta.x + slidePos[index + 1], 0);

      }

    },
    end: function(event) {

      // measure duration
      var duration = +new Date - start.time;

      // determine if slide attempt triggers next/prev slide
      var isValidSlide =
        Number(duration) < 250 // if slide duration is less than 250ms
        && Math.abs(delta.x) > 20 // and if slide amt is greater than 20px
        || Math.abs(delta.x) > width / 2; // or if slide amt is greater than half the width

      // determine if slide attempt is past start and end
      var isPastBounds = !index && delta.x > 0 // if first slide and slide amt is greater than 0
        || index == slides.length - 1 && delta.x < 0; // or if last slide and slide amt is less than 0

      // determine direction of swipe (true:right, false:left)
      var direction = delta.x < 0;

      // if not scrolling vertically
      if (!isScrolling) {

        if (isValidSlide && !isPastBounds) {

          if (direction) {

            move(index - 1, -width, 0);
            move(index, slidePos[index] - width, speed);
            move(index + 1, slidePos[index + 1] - width, speed);
            index += 1;

          } else {

            move(index + 1, width, 0);
            move(index, slidePos[index] + width, speed);
            move(index - 1, slidePos[index - 1] + width, speed);
            index += -1;

          }

          options.callback && options.callback(index, slides[index]);

        } else {
          //触摸滑动时实现循环播放
          if (isPastBounds) {
            if (index == 0) {
              slide(slides.length - 1);
            } else {
              slide(0);
            }
          } else {
            move(index - 1, -width, speed);
            move(index, 0, speed);
            move(index + 1, width, speed);
          }

        }

      }

      // kill touchmove and touchend event listeners until touchstart called again
      element.removeEventListener('touchmove', events, false)
      element.removeEventListener('touchend', events, false)
      Comment.isCanScrollBack(true);
      Comment.isCanScrollForwardBack(true);
    },
    transitionEnd: function(event) {

      if (parseInt(event.target.getAttribute('data-index'), 10) == index) {

        if (delay) begin();

        options.transitionEnd && options.transitionEnd.call(event, index, slides[index]);

      }

    }

  }

  // trigger setup
  setup();

  // start auto slideshow if applicable
  if (delay) begin();


  // add event listeners
  if (browser.addEventListener) {

    // set touchstart event on element
    if (browser.touch) element.addEventListener('touchstart', events, false);

    if (browser.transitions) {
      element.addEventListener('webkitTransitionEnd', events, false);
      element.addEventListener('msTransitionEnd', events, false);
      element.addEventListener('oTransitionEnd', events, false);
      element.addEventListener('otransitionend', events, false);
      element.addEventListener('transitionend', events, false);
    }

    // set resize event on window
    window.addEventListener('resize', events, false);

  } else {

    window.onresize = function() {
      setup()
    }; // to play nice with old IE

  }

  // expose the Swipe API
  return {
    setup: function() {

      setup();

    },
    slide: function(to, speed) {

      slide(to, speed);

    },
    prev: function() {

      // cancel slideshow
      stop();

      prev();

    },
    next: function() {

      stop();

      next();

    },
    getPos: function() {

      // return current index position
      return index;

    },
    kill: function() {

      // cancel slideshow
      stop();

      // reset element
      element.style.width = 'auto';
      element.style.left = 0;

      // reset slides
      var pos = slides.length;
      while (pos--) {

        var slide = slides[pos];
        slide.style.width = '100%';
        slide.style.left = 0;
        if (browser.transitions) translate(pos, 0, 0);

      }

      // removed event listeners
      if (browser.addEventListener) {

        // remove current event listeners
        element.removeEventListener('touchstart', events, false);
        element.removeEventListener('webkitTransitionEnd', events, false);
        element.removeEventListener('msTransitionEnd', events, false);
        element.removeEventListener('oTransitionEnd', events, false);
        element.removeEventListener('otransitionend', events, false);
        element.removeEventListener('transitionend', events, false);
        window.removeEventListener('resize', events, false);

      } else {
        window.onresize = null;
      }

    }
  }
}

if (window.jQuery || window.Zepto) {
  (function($) {
    $.fn.Swipe = function(params) {
      return this.each(function() {
        $(this).data('Swipe', new Swipe($(this)[0], params));
      });
    }
  })(window.jQuery || window.Zepto)
}

//新增第三方的视频需求16-12-28
$(function() {
  $('a[data-type=video]').each(function() {
    var $video = $(this);
    var provider = $video.text().trim();
    var urlText = $video.attr('href');
    var videohtml = [
      '<span class="url">',
      '<span class="source">' + provider + '</span>' + urlText,
      '</span>',
      '<span class="btn">查看视频<i></i></span>'
    ].join('');
    $video.parents('p').first().addClass('third-video');
    $video.empty().append($(videohtml));
  });
})
